//
//  BatteryView.m
//  DemoForBattery
//
//  Created by benjaminlmz@qq.com on 2020/3/18.
//  Copyright © 2020 Tony. All rights reserved.
//

#import "BatteryView.h"
#define redColor [UIColor colorWithRed:1 green:0.3 blue:0.3 alpha:1]
#define blueColor  [UIColor colorWithRed:0.3 green:0.7 blue:0.8 alpha:1]
#define orangeColor [UIColor colorWithRed:1 green:0.8 blue:0.2 alpha:1]
#define whiteColor [UIColor colorWithRed:1 green:1 blue:1 alpha:1]
#define lineWidth 1
#define widthEdge self.frame.size.width/50
@interface BatteryView() {
    CGContextRef ctx;
    float percent;
}

@property (nonatomic ,assign)float ;
@end

@implementation BatteryView


- (id)initWithFrame:(CGRect)frame {
    self = [super initWithFrame:frame];
    if (self) {
        self.backgroundColor = [UIColor clearColor];

        self.opaque = YES;
        percent = 0;
        [NSTimer scheduledTimerWithTimeInterval:0.01 repeats:YES block:^(NSTimer * _Nonnull timer) {
            if (self->percent < 1) {
                self->percent = self->percent + 0.002;
            }else {
                self->percent = 0;
            }

            
            [self setNeedsDisplay];
        }];
    }
    
    return self;
}

- (void)drawRect:(CGRect)rect {
    [self drawBatteryView];

}
- (void)drawBatteryView {
    ctx = UIGraphicsGetCurrentContext();
    CGContextSetLineWidth(ctx, lineWidth);//线的宽度
    UIColor *aColor = whiteColor;
    CGContextSetFillColorWithColor(ctx, aColor.CGColor);//填充颜色
    CGContextSetLineJoin(ctx, kCGLineJoinRound);
    if (percent > 0.75) {
        aColor = blueColor;
    }else if (percent <= 0.75 && percent > 0.4) {
        aColor = orangeColor;
    }else if (percent <= 0.4) {
        aColor = redColor;
    }
    //外框
    CGContextSetStrokeColorWithColor(ctx, aColor.CGColor);//线框颜色
    CGContextSetFillColorWithColor(ctx, aColor.CGColor);//填充颜色
    
    CGContextAddRoundRect(ctx, CGRectMake(widthEdge, self.frame.size.height * 0.5 - (self.frame.size.width/2.5)/2, self.frame.size.width * 0.9 - widthEdge, self.frame.size.width/2.5),kCGPathStroke, widthEdge/2);
    
    CGContextAddRoundRect(ctx, CGRectMake(widthEdge + widthEdge + lineWidth, self.frame.size.height * 0.5 - (self.frame.size.width/2.5 - widthEdge * 2)/2 + widthEdge/2, (self.frame.size.width * 0.9 - widthEdge - widthEdge * 2 - lineWidth)*percent, self.frame.size.width/2.5 - widthEdge * 2 - widthEdge), kCGPathFillStroke,widthEdge/2);
    //头
    CGContextAddRoundRect(ctx, CGRectMake(self.frame.size.width * 0.9, self.frame.size.height /2 - (self.frame.size.width/4)/2, self.frame.size.width * 0.08 - widthEdge, self.frame.size.width/4),kCGPathFillStroke, widthEdge/2);
    
    [self drawLightView];
}
- (void)drawLightView {
    UIColor *aColor = whiteColor;
    CGContextSetStrokeColorWithColor(ctx, aColor.CGColor);//线框颜色
    CGContextSetFillColorWithColor(ctx, aColor.CGColor);//填充颜色

    CGContextMoveToPoint(ctx,self.frame.size.width/2,self.frame.size.height * 0.5 - (self.frame.size.width/2.5 - widthEdge * 2)/2 + widthEdge);
    CGContextAddLineToPoint(ctx, self.frame.size.width/2 - widthEdge*1.5, self.frame.size.height/2);
    CGContextAddLineToPoint(ctx, self.frame.size.width/2 , self.frame.size.height/2 + widthEdge);
    
    
    CGContextAddLineToPoint(ctx, self.frame.size.width/2 , self.frame.size.height * 0.5 + (self.frame.size.width/2.5 - widthEdge * 2)/2 - widthEdge);
    CGContextAddLineToPoint(ctx, self.frame.size.width/2 + widthEdge*1.5, self.frame.size.height/2);
    
    CGContextAddLineToPoint(ctx, self.frame.size.width/2 , self.frame.size.height * 0.5 - widthEdge);
    CGContextClosePath(ctx);
    CGContextDrawPath(ctx, kCGPathFillStroke);
}


void CGContextAddRoundRect(CGContextRef context,CGRect rect,CGPathDrawingMode mode,CGFloat radius){
    float x1=rect.origin.x;
    float y1=rect.origin.y;
    float x2=x1+rect.size.width;
    float y2=y1;
    float x3=x2;
    float y3=y1+rect.size.height;
    float x4=x1;
    float y4=y3;
    CGContextMoveToPoint(context, x1, y1+radius);
    CGContextAddArcToPoint(context, x1, y1, x1+radius, y1, radius);
    
    CGContextAddArcToPoint(context, x2, y2, x2, y2+radius, radius);
    CGContextAddArcToPoint(context, x3, y3, x3-radius, y3, radius);
    CGContextAddArcToPoint(context, x4, y4, x4, y4-radius, radius);
    
    CGContextClosePath(context);
    CGContextDrawPath(context, mode); //根据坐标绘制路径
}
@end
