//
//  WaveBallView.m
//  DemoForBattery
//
//  Created by benjaminlmz@qq.com on 2020/3/19.
//  Copyright © 2020 Tony. All rights reserved.
//
// 这是一个球内波浪动画控件
#import "WaveBallView.h"
#define UIColorFromRGB(rgbValue,a) ([UIColor colorWithRed:((float)((rgbValue & 0xFF0000) >> 16))/255.0 green:((float)((rgbValue & 0xFF00) >> 8))/255.0 blue:((float)(rgbValue & 0xFF))/255.0 alpha:(a)])
@interface WaveBallView() {
    CGContextRef ctx;
}
@end

@implementation WaveBallView


- (id)initWithFrame:(CGRect)frame {
    self = [super initWithFrame:frame];
    if (self) {
        self.backgroundColor = [UIColor clearColor];
    }
    return self;
}


- (void)drawRect:(CGRect)rect {
    // Drawing code
    [self drawBackgroundCircle];

}

- (void)drawBackgroundCircle {
    ctx = UIGraphicsGetCurrentContext();
    UIColor *fillColor = UIColorFromRGB(0x49A6F6,0.2);
    CGContextSetLineWidth(ctx, 0);
    CGContextSetStrokeColorWithColor(ctx, fillColor.CGColor);
    CGContextSetFillColorWithColor(ctx, fillColor.CGColor);
    CGContextAddArc(ctx, self.frame.size.width * 0.5, self.frame.size.height * 0.5, self.frame.size.width * 0.47, 0, 2 * M_PI, 0);
    CGContextDrawPath(ctx,kCGPathFillStroke); //根据坐标绘制路径
    
    UIColor *fillColor2 = UIColorFromRGB(0x49A6F6,0.3);
    CGContextSetStrokeColorWithColor(ctx, fillColor2.CGColor);
    CGContextAddArc(ctx, self.frame.size.width * 0.5, self.frame.size.height * 0.5, self.frame.size.width * 0.44, 0, 2 * M_PI, 0);
    CGContextDrawPath(ctx,kCGPathFillStroke); //根据坐标绘制路径

    UIColor *fillColor3 = UIColorFromRGB(0x49A6F6,0.4);
    CGContextSetStrokeColorWithColor(ctx, fillColor3.CGColor);
    CGContextAddArc(ctx, self.frame.size.width * 0.5, self.frame.size.height * 0.5, self.frame.size.width * 0.41, 0, 2 * M_PI, 0);
    CGContextDrawPath(ctx,kCGPathFillStroke); //根据坐标绘制路径

    UIColor *fillColor4 = UIColorFromRGB(0x49A6F6,1);
    CGContextSetStrokeColorWithColor(ctx, fillColor4.CGColor);
    CGContextAddArc(ctx, self.frame.size.width * 0.5, self.frame.size.height * 0.5, self.frame.size.width * 0.38, 0, 2 * M_PI, 0);
    CGContextDrawPath(ctx,kCGPathFillStroke); //根据坐标绘制路径
}

- (void)drawWaveBarsView {


}

    
//void CGContextAddRoundRect(CGContextRef context,CGRect rect,CGPathDrawingMode mode,CGFloat radius){
//    float x1=rect.origin.x;
//    float y1=rect.origin.y;
//    float x2=x1+rect.size.width;
//    float y2=y1;
//    float x3=x2;
//    float y3=y1+rect.size.height;
//    float x4=x1;
//    float y4=y3;
//    CGContextMoveToPoint(context, x1, y1+radius);
//    CGContextAddArcToPoint(context, x1, y1, x1+radius, y1, radius);
//    CGContextAddArcToPoint(context, x2, y2, x2, y2+radius, radius);
//    CGContextAddArcToPoint(context, x3, y3, x3-radius, y3, radius);
//    CGContextAddArcToPoint(context, x4, y4, x4, y4-radius, radius);
//
//    CGContextClosePath(context);
//    CGContextDrawPath(context, mode); //根据坐标绘制路径
//}

@end
